/**
 * This file was generated by the Objective Systems ASN1C Compiler
 * (http://www.obj-sys.com).  Version: 7.5.0, Date: 09-Mar-2021.
 */
#include "NRPPA-PDU-Descriptions.h"
#include "NRPPA-Constants.h"
#include "rtxsrc/rtxCommon.h"

#include "rtxsrc/rtxPrint.h"

/* function for populating an InitiatingMessage */
InitiatingMessage *populate_InitMsg (OSCTXT *pctxt);

int main (int argc, char** argv)
{
   /* PDU: NRPPA-PDU-Descriptions.NRPPA_PDU */
   NRPPA_PDU  pdu;
   OSCTXT     ctxt;
   int        i, len, stat;
   OSBOOL     trace = TRUE;
   OSBOOL     verbose = FALSE;
   const char* filename = "message.per";
   const OSOCTET* msgptr;

   /* Process command line arguments */
   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>]  [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 1;
         }
      }
   }

   /* Initialize context structure */
   stat = rtInitContext (&ctxt);
   if (stat != 0) {
      rtxErrPrint (&ctxt);
      return stat;
   }
   rtxSetDiag (&ctxt, verbose);
   pu_setBuffer (&ctxt, 0, 0, TRUE);
   pu_setTrace (&ctxt, trace);

   pdu.t = T_NRPPA_PDU_initiatingMessage;
   pdu.u.initiatingMessage = populate_InitMsg (&ctxt);

   if (trace) {
      printf ("The following record will be encoded:\n");
      asn1Print_NRPPA_PDU ("NRPPA_PDU", &pdu);
      printf ("\n");
   }

   /* Encode */
   if ((stat = asn1PE_NRPPA_PDU (&ctxt, &pdu)) == 0) {
      if (trace) {
         printf ("Encoding was successful\n");
         printf ("Hex dump of encoded record:\n");
         pu_hexdump (&ctxt);
         printf ("Binary dump:\n");
         pu_bindump (&ctxt, "NRPPA_PDU");
      }
   }
   else {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
      rtFreeContext (&ctxt);
      return -1;
   }
   msgptr = pe_GetMsgPtr (&ctxt, &len);

   /* Write the encoded message out to the output file */
   stat = rtxFileWriteBinary (filename, msgptr, len);
   if (stat < 0) {
      printf ("Error opening %s for write access\n", filename);
   }

   rtFreeContext (&ctxt);

   return stat;
}

InitiatingMessage *populate_InitMsg (OSCTXT *pctxt)
{
   InitiatingMessage* pvalue = rtxMemAllocType (pctxt, InitiatingMessage);
   asn1Init_InitiatingMessage (pvalue);

   pvalue->procedureCode = ASN1V_id_e_CIDMeasurementTermination;
   pvalue->criticality = Criticality_reject;
   pvalue->nrppatransactionID = 24062;

   pvalue->value.t = T_NRPPAPDUDescr_NPEP_e_CIDMeasurementTermination;
   pvalue->value.u.e_CIDMeasurementTermination = rtxMemAllocTypeZ (pctxt, E_CIDMeasurementTerminationCommand);

   {
      OSRTDList* plist = &pvalue->value.u.e_CIDMeasurementTermination->protocolIEs;
      E_CIDMeasurementTerminationCommand_protocolIEs_element* pdata;
      rtxDListInit (plist);

      pdata = rtxMemAllocTypeZ (pctxt, E_CIDMeasurementTerminationCommand_protocolIEs_element);

      pdata->id = ASN1V_id_LMF_UE_Measurement_ID;
      pdata->criticality = Criticality_reject;

      pdata->value.t = T_NRPPAPDUCont_E_CIDMeasurementTerminationCommand_IEs_id_LMF_UE_Measurement_ID;
      pdata->value.u._E_CIDMeasurementTerminationCommand_IEs_id_LMF_UE_Measurement_ID = 4;

      rtxDListAppend (pctxt, plist, (void*)pdata);

      pdata = rtxMemAllocTypeZ (pctxt, E_CIDMeasurementTerminationCommand_protocolIEs_element);

      pdata->id = ASN1V_id_RAN_UE_Measurement_ID;
      pdata->criticality = Criticality_reject;

      pdata->value.t = T_NRPPAPDUCont_E_CIDMeasurementTerminationCommand_IEs_id_RAN_UE_Measurement_ID;
      pdata->value.u._E_CIDMeasurementTerminationCommand_IEs_id_RAN_UE_Measurement_ID = 14;

      rtxDListAppend (pctxt, plist, (void*)pdata);
   }
   return (pvalue);
}

